02/27/2021 04:22 PM - Eregon (Benoit Daloze)

Status: Assigned   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Description

This heredoc pattern

    assert_ruby_status([], "#{<<-"begin;"}\n#{<<-'end;'}", bug)

    begin;

      exit("1" == Thread.start(1, &:to_s).value)

    end;

 completely breaks syntax highlighting in at least:

GitHub: there are many examples

Atom

RubyMine (and IntelliJ)

Likely many more editors based on TextMate grammars

Could another pattern be used in tests inside the ruby/ruby repository (at least for test/ruby)?

Due to this issue, it is very annoying and inconvenient to look at/read/investigate many tests.

I think this pattern is also very complicated to understand (and using ; is quite weird for this).

I suggest to replace it with this obvious and simple pattern many people use:

    assert_ruby_status([], <<~'RUBY', bug)

      exit("1" == Thread.start(1, &:to_s).value)

    RUBY

 This syntax highlights correctly in most (all?) editors, and as an added bonus the code inside the heredoc is also highlighted in some

editors (due to the label being RUBY).

History

#1 - 02/27/2021 04:23 PM - Eregon (Benoit Daloze)

- Subject changed from The herdoc pattern used in tests does not syntax highlight correctly in many editors to The heredoc pattern used in tests does

not syntax highlight correctly in many editors

#2 - 02/27/2021 06:16 PM - xtkoba (Tee KOBAYASHI)

In the suggested pattern, the here document seems not highlighted nor auto-indented by Emacs Ruby Mode. Would you please also suggest the

configuration of Emacs Ruby Mode for the suggested pattern?

#3 - 02/28/2021 11:19 AM - Eregon (Benoit Daloze)

I'm not an Emacs user, so I don't know.

I think indentation doesn't matter much, it could be this too:

    assert_ruby_status([], <<~'RUBY', bug)

    exit("1" == Thread.start(1, &:to_s).value)

    RUBY

 Highlighting the Ruby code inside the heredoc seems a nice extra, but the issue of not highlighting the entire file due to the pattern seems much

worse.

I guess the best would be if the Emacs Ruby Mode implements highlighting if the heredoc label is RUBY.

I'm open to see other patterns that might work better on Emacs and still don't destroy syntax highlighting of the file in other editors.

#4 - 02/28/2021 07:33 PM - xtkoba (Tee KOBAYASHI)

Emacs Ruby Mode behaves well with the current pattern. I wonder why the other editors do not simulate it.

06/17/2025 1/3

https://github.com/ruby/ruby/blob/36dde35e029c7a6607e6c674062ce6fc7a51c0bd/test/ruby/test_string.rb#L697
https://github.com/ruby/ruby/blob/36dde35e029c7a6607e6c674062ce6fc7a51c0bd/test/ruby/test_process.rb#L1545
https://github.com/ruby/ruby/blob/565aeb81e0886c835888a425e5d05ed99fb03238/test/ruby/test_thread.rb#L201
https://github.com/ruby/ruby/blob/36dde35e029c7a6607e6c674062ce6fc7a51c0bd/test/ruby/test_require.rb#L21


#5 - 02/28/2021 11:20 PM - marcandre (Marc-Andre Lafortune)

It's a really complex formulation: a double HEREDOC inside string interpolatiosn, with a delimiter of the HEREDOC using double quotes but clearly

that's not the end of the string because it's inside a #{}...

I can barely makes sense of it myself.

#6 - 03/01/2021 12:36 AM - mame (Yusuke Endoh)

- Status changed from Open to Assigned

- Assignee set to nobu (Nobuyoshi Nakada)

My vim works great with the code :-) But breaking syntax highligt in GitHub is not so great.

AFAIK the style is mainly written by @nobu (Nobuyoshi Nakada). Nobu, what do you think?

#7 - 03/08/2021 07:30 AM - nobu (Nobuyoshi Nakada)

I don't mind to transfer to <<~RUBY if ruby-mode.el supporting it gets released.

BTW, what editors support it?

#8 - 03/08/2021 07:37 AM - nobu (Nobuyoshi Nakada)

Also, does auto indentation work inside <<~RUBY as begin;...end; hack?

#9 - 03/08/2021 08:12 AM - mame (Yusuke Endoh)

Okay, the style is an intentional hack to trick the editors into syntax-highlinting and auto-indenting the code within the heredoc. I didn't know, but it

makes sense to me.

I investigated the syntax highlighting behavior of GitHub. They does not correctly support an empty heredoc in an indent:

https://gist.github.com/mame/90c1427163266ba73fab4cf7d96edd0a

I think they should fix it, but I found one workaround: adding a new line in <<"begin;" heredoc solves the issue.

https://github.com/ruby/ruby/blob/d10b535806227d24a3f8f5c7f425be3a39c2ac74/test/ruby/test_string.rb#L697

#10 - 03/15/2021 08:10 AM - mame (Yusuke Endoh)

mame (Yusuke Endoh) wrote in #note-9:

I investigated the syntax highlighting behavior of GitHub. They does not correctly support an empty heredoc in an indent:

https://gist.github.com/mame/90c1427163266ba73fab4cf7d96edd0a

 Wow, it looks like that GitHub fixed the issue. The code is now colored correctly as a heredoc. Great.

Eregon (Benoit Daloze) wrote:

completely breaks syntax highlighting in at least:

GitHub: there are many examples

 These lines are also syntax-highlighted correctly.

For the record: when this ticket was created, all the code after the heredoc was not colored at all in GitHub file view.

#11 - 03/15/2021 04:24 PM - marcandre (Marc-Andre Lafortune)

Great for Github!

FWIW, both VS Code and Sublime Text get very confused by this pattern.

#12 - 06/22/2021 11:29 AM - Eregon (Benoit Daloze)

Here is a particularly weird/complex example usage of heredocs in tests:

https://github.com/ruby/ruby/blob/eef3c08edc2fc74496cdc1e4d89798d053e32561/test/ruby/test_thread.rb#L1380-L1394

It does not syntax highlight, it is very hard to read, and the {#1 nesting seems there for no reason after 2 lines of code?

The inner script is actually just:

code = <<~RUBY
https://redmine.ruby-lang.org/users/4
https://gist.github.com/mame/90c1427163266ba73fab4cf7d96edd0a
https://github.com/ruby/ruby/blob/d10b535806227d24a3f8f5c7f425be3a39c2ac74/test/ruby/test_string.rb#L697
https://gist.github.com/mame/90c1427163266ba73fab4cf7d96edd0a
https://github.com/ruby/ruby/blob/36dde35e029c7a6607e6c674062ce6fc7a51c0bd/test/ruby/test_string.rb#L697
https://github.com/ruby/ruby/blob/36dde35e029c7a6607e6c674062ce6fc7a51c0bd/test/ruby/test_process.rb#L1545
https://github.com/ruby/ruby/blob/565aeb81e0886c835888a425e5d05ed99fb03238/test/ruby/test_thread.rb#L201
https://github.com/ruby/ruby/blob/36dde35e029c7a6607e6c674062ce6fc7a51c0bd/test/ruby/test_require.rb#L21
https://github.com/ruby/ruby/blob/eef3c08edc2fc74496cdc1e4d89798d053e32561/test/ruby/test_thread.rb#L1380-L1394


tpid = #{Process.pid}

sig = :#{sig}

STDOUT.sync = true

while gets

  puts

  Process.kill(sig, tpid)

end

RUBY

 I think it would be great to consolidate to a single style of heredoc in tests,

and if possible one that does not involve twice the number of heredocs than needed.

#13 - 06/30/2021 12:54 PM - nobu (Nobuyoshi Nakada)

Eregon (Benoit Daloze) wrote in #note-12:

and if possible one that does not involve twice the number of heredocs than needed.

 It is intentional to indent inside here-docs and separate interpolation-enabled and -disabled parts.
